#include <stdio.h>
#include <cv/dosinfo.h>

#pragma warn -ccc
#pragma warn -rch
#define CHECKSZ(rec, sz) printf("%-15s= %u byte(s)\n", #rec, sizeof(rec));\
			 if(sizeof(rec) != (sz)){			\
				puts("Error: internal " #rec		\
				" size error"); return 1; }

int main(){
	CHECKSZ(MCB, 16);
	CHECKSZ(PSP, 256);

	CHECKSZ(DevAttr, 2);
	CHECKSZ(DevHdr, 18);
	CHECKSZ(DevCDROM, sizeof(DevHdr) + 10);
	CHECKSZ(DevInterlnk, sizeof(DevHdr) + 335);
	CHECKSZ(LZSinfo, 60);
	CHECKSZ(DevStacker, sizeof(DevHdr) + 120);
	CHECKSZ(DevStacker4, sizeof(DevStacker) + 220 + sizeof(LZSinfo));

	CHECKSZ(BPB, 13);
	CHECKSZ(Dos2BPB, sizeof(BPB) + 6);
	CHECKSZ(Dos3BPB, sizeof(BPB) + 8);
	CHECKSZ(Dos4BPB, sizeof(Dos3BPB) + 4);
	CHECKSZ(Dos4BPBe, sizeof(Dos4BPB) + 11);
	CHECKSZ(ExtBPB, sizeof(Dos4BPB) + 28);

	CHECKSZ(DPB, 33);
	CHECKSZ(CDS, 88);

	CHECKSZ(Dos2SFT, 46);
	CHECKSZ(Dos3SFT, 62);
	CHECKSZ(Dos3xSFT, 59);
	CHECKSZ(Dos4SFT, 65);

	CHECKSZ(DospreLoL, 2);
	CHECKSZ(Dos3preLoL, sizeof(DospreLoL) + 6);
	CHECKSZ(Dos3xpreLoL, sizeof(Dos3preLoL) + 16);

	CHECKSZ(DosLoL, 16);
	CHECKSZ(Dos2LoL, sizeof(DosLoL) + 7 + sizeof(DevHdr));
	CHECKSZ(Dos3LoL, sizeof(DosLoL) + 24 + sizeof(DevHdr));
	CHECKSZ(Dos3xLoL, sizeof(DosLoL) + 19 + sizeof(DevHdr));
	CHECKSZ(Dos4LoL, sizeof(Dos3xLoL) + 18);
	CHECKSZ(DosBoxLoL, sizeof(DosLoL) + 18 + sizeof(DevHdr));
	return 0;
}
