#include "inc/heapstk.inc"


//---------------------------------------------------------
void* SMALL_ HeapStack::alloc(size_t sz){
	if(sz == 0) return NULL;
	count dsz;

	//--- 뤥    室
	if(sz > p.avail){
		dsz = BlockSize - BlockHeadSz(); if(sz > dsz) dsz = sz;
		Block *pb = (Block*)malloc(dsz + BlockHeadSz());
		if(pb == NULL) return NULL;

		if(p.block) p.used += p.dsize - p.avail, p.lost += p.avail;
		pb->prev = (Block*)p.block; p.block = pb;
		p.avail = p.dsize = dsz;
	}

	//--- १ 室 ᥣ
	dsz = p.dsize - p.avail; p.avail -= sz;
	return &((Block*)p.block)->d[dsz];
}
