1   REM - THE CLASSIC LEMONADE GAME.  COPYRIGHT (C) 1998 JIM HALL
2   REM - YOU GET TO SELL LEMONADE.  TO DO THIS WELL, YOU NEED TO
3   REM - RESPOND TO THE WEATHER AND MAKE THE RIGHT AMOUNT OF LEMONADE
4   REM - TO SELL.
5   REM - YOU HAVE 20 DAYS TO MAKE OR BREAK THE BANK!  :-)

6   REM - UPDATED BY TIMOTHY J. MASSEY (tmassey@iname.com)

10  CLS : PRINT "THIS IS THE CLASSIC LEMONADE GAME!"
11  PRINT "YOU GET TO SELL LEMONADE.  TO DO THIS WELL, YOU WILL NEED"
12  PRINT "TO TELL ME HOW MUCH LEMONADE YOU WANT TO MAKE.  YOU WILL"
13  PRINT "NEED TO RESPOND TO THE WEATHER AND THE COST OF MAKING YOUR"
14  PRINT "LEMONADE."
15  PRINT "YOUR MOM WILL SPOT YOU $10 TO START WITH.  AFTER THAT, YOU"
16  PRINT "ARE ON YOUR OWN.  THE COST OF MAKING A GLASS OF LEMONADE"
17  PRINT "WILL START AT 10 CENTS EACH."
18  PRINT "YOU HAVE 20 DAYS TO MAKE IT OR BREAK IT!"

19  DEFINT A-Z
20  REM - SET VARIABLES.
30  LET CST = 10
40  LET INI = 1000: LET TOT = INI
50  LET DAY = 0
60  LET TMP = 75
70  RANDOMIZE TIMER

99  REM - START SELLING LEMONADE
100 IF TOT < CST OR DAY > 20 THEN GOTO 900
101 GOSUB 6000: GOSUB 5000: LET DAY = DAY + 1
102 PRINT : PRINT "IT COSTS "; CST; " CENTS TO MAKE A GLASS OF LEMONADE"
103 INPUT "HOW MANY GLASSES OF LEMONADE TO MAKE? "; N
104 IF (N * CST) > TOT THEN PRINT "YOU CANT MAKE THAT MUCH": GOTO 103
105 INPUT "WHAT WILL YOU CHARGE PER GLASS? (CENTS) "; P

110 REM - FIGURE OUT RESULTS FOR THIS ITERATION
120 LET TOT = TOT - (N * CST)
130 LET TMP = T + INT((RND * 3) + .2) - INT((RND * 3) + .2)

140 REM - FIGURE CUSTOMER RESPONSE
150 IF INT(RND * 100) < R THEN GOTO 800
160 LET SAL = RND * TMP * (1 + CST) / (1 + P)
165 IF P > (3 * CST) THEN LET SAL = SAL / 10
170 IF TMP > 80 THEN LET SAL = SAL / 80 * TMP
175 IF TMP < 60 THEN LET SAL = SAL / 3
176 IF TMP < 50 THEN LET SAL = 0
180 SAL = INT(SAL): IF SAL > N THEN GOTO 185
182 GOTO 190
185 REM PRINT : PRINT "YOU COULD HAVE SOLD " + STR$(SAL - N) + " MORE!"
187 SAL = N

190 REM - FIGURE INCOME FROM SALES
200 PRINT : PRINT "NO. OF GLASSES ACTUALLY SOLD: "; SAL
210 LET TOT = TOT + (SAL * P)

799 GOTO 100

800 REM - RAIN.  NO SALES!
810 PRINT : PRINT "IT RAINED!  THERE ARE NO SALES FOR YOU TODAY.  :-("
820 GOTO 100

900 REM - THE END
910 IF TOT < 1 THEN LET TOT = 0
920 GOSUB 5000
930 IF TOT > INI THEN PRINT "YOU MADE SOME MONEY AT IT!"
940 IF TOT > 0 AND TOT <= INI THEN PRINT "AT LEAST YOU DIDNT GO BROKE."
950 IF TOT <= 0 THEN PRINT "YOU ARE SUCH A LOSER AT THIS GAME!"

999 END

5000 REM - A SUBROUTINE TO PRINT TODAYS INFORMATION
5009 PRINT : PRINT
5010 PRINT "-----------------------------------------------------------"
5020 PRINT "DAY "; DAY
5021 PRINT "$"; TOT / 100!
5030 PRINT "TEMPERATURE: "; TMP; " (F)"
5040 REM - PRINT PREDICTIONS FOR TOMORROW
5050 LET T = TMP + INT(RND * 10) - INT(RND * 10)
5060 LET R = INT(1 + RND * 3) * 10
5070 PRINT "TOMORROW SHOULD BE "; T; " WITH "; R; "% CHANCE OF RAIN"
5080 PRINT "-----------------------------------------------------------"
5090 RETURN

6000 IF DAY <> 10 THEN RETURN
6010 REM - FIGURE A RATE INCREASE
6020 PRINT : PRINT "YOUR MOM STOPS LETTING YOU BORROW HER SUGAR.  YOU MUST NOW"
6030 PRINT "BUY YOUR OWN.  THE COST OF MAKING LEMONADE JUST WENT UP 5"
6040 PRINT "CENTS PER GLASS."
6050 LET CST = CST + 5
6060 RETURN

