#ifndef _h_TYPES_
# include <cv/types.h>
#endif


#ifndef _cv_DEBUG
  #define _cv_DEBUG 2
#endif


externC
#if defined(__TURBOC__) && __TURBOC__ == 0x410
	void _Cdecl _FARFUNC __assertfail(char _FAR *msg, char _FAR *cond,
						char _FAR *file, int line);
	#define _cv_assert(msg, cond, f, l) __assertfail(msg, cond, f, l)
#else
	void SMALL_ _cv_assert(CStr msg, CStr cond, CStr file, int line);
#endif


/*---------------------------------------------------------*/
#undef PRE
#undef PRE2

#if _cv_DEBUG < 2
  #define PRE(p)
  #define PRE2(p, err)
#else
  #define PRE(p)	if(p);else _cv_assert("\nPrecondition violated: %s," \
			" file %s, line %d\n", #p, __FILE__, __LINE__)
  #define PRE2(p, err)	if(p);else _cv_assert("\nPrecondition violated: %s," \
			" file %s, line %d\n", err, __FILE__, __LINE__)
#endif


/*---------------------------------------------------------*/
#undef CHECK
#undef CHECK2

#if _cv_DEBUG < 1
  #define CHECK(p)
  #define CHECK2(p, err)
#else
  #define CHECK(p)	if(p);else _cv_assert("\nCheck failed: %s,"	\
			" file %s, line %d\n", #p, __FILE__, __LINE__)
  #define CHECK2(p,err)	if(p);else _cv_assert("\nCheck failed: %s,"	\
			" file %s, line %d\n", err, __FILE__, __LINE__)
#endif


/*---------------------------------------------------------*/
#define ABSTRACT()	_cv_assert("\nAbstract method called:%s"	\
			" file %s, line %d\n", "", __FILE__, __LINE__)
#define ABSTRACT2(err)	_cv_assert("\nAbstract method called: %s,"	\
			" file %s, line %d\n", err, __FILE__, __LINE__)
