#include "libdef.inc"
#if !defined(STD_CODE) && defined(ASM86_CODE)
# include <cv/asm86.h>
#endif
#include <cv/string2.h>


/*----------------------------------------------------------------------*/
/*     ப						*/
String& SMALL_ reverse(String &s){
#if defined(STD_CODE) || !defined(ASM86_CODE)
	for(count left = 0, right = s.len; left < right; left++){
		right--; register char c = s[left];
		s[left] = s[right]; s[right] = c;
	}
#else
#  ifdef FARDATA
	_DX = _DS;
#  endif
	I LDS_ bx, DPTR_(s);			/* DS_:bx = s		*/
	I mov di, [bx].(String)len;
	I lea si, [bx].(String)str;		/* si = &s[0]		*/
	_DI += _SI;				/* di = &s[s.len]	*/
	for(; _SI < _DI; _SI++){
		_DI--; I mov al, [si];		/* right--, temp = s[left] */
		I mov ah, [di];
		I mov [si], ah;			/* s[left] = s[right]	*/
		I mov [di], al;			/* s[right] = temp	*/
	}
#  ifdef FARDATA
	_DS = _DX;
#  endif
#endif
	return s;
}
