/*
    SUPPL - a supplemental library for common useage
    Copyright (C) 1995,1996  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/* $RCSfile: PEEKD.C $
   $Locker:  $	$Name:  $	$State: Exp $

	peekd(word seg, word ofs, dword *addr)

	copying the dword value from the far memory.
	If addr is NULL, the copy is suppressed.
	Micro-C only.

	Return:	== 0: the dword value is zero
			!= 0: otherwise

*/

#ifdef _MICROC_
#include <portable.h>

#ifndef lint
static char const rcsid[] = 
	"$Id: PEEKD.C 2.1 1996/11/08 03:18:16 ska Exp $";
#endif

peekd(nM(word) segm, nM(word) ofs, nM(dword *) addr)
{ asm {
	les si, asmName(ofs,6)			; /* source */
	mov bx, asmName(addr,4)			; /* destination address */
	or bx, bx						; /* suppress copying? */
	je peekd1						; /* yes */
	lods Word Ptr es:[si]
	mov [bx], ax
	mov cx, Word Ptr es:[si]
	mov 2[bx], cx
	or ax, cx
	jmp short peekd2
asmLabel(peekd1)					; /* test only */
	lods Word Ptr es:[si]
	or ax, es:[si]
asmLabel(peekd2)
}
}
#endif
